<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for switching bool fields
  *
  * Switching means updating the database fields from type bool,
  * Updating will write 0 or 1 to the database.
  *
  * @since 2010-12
  */

class Bool_Switch extends Dbc 
{
    private $field_name;
    private $id;
    private $inactive = false;
    private $content;
    private $tbl;


    /**
     * Shows a link for switching boolean fields in database
     * @param mixed $field_value
     * @param string $condition
     * @param bool $style
     * @return string
     */
    function bool_link($field_value, $condition = 1, $style = '')
    {
        // Link or span if inactive
        if ($condition) {
            if ($this->inactive == true) {
                $a_or_span = 'span';
            }else{
                $a_or_span = 'a';
            }
            
            $l = $_SERVER['PHP_SELF'] . '?'.$this->field_name.'=' . $field_value 
               . '&amp;tbl=' . $this->tbl . '&amp;id=' . $this->id;
            $link = ' <span ' . $style . '><' . $a_or_span . ' href="' . $l . '">';
            if($field_value != 1) {
                $link .= '<img src="' . PROJECT_HTTP_ROOT . 'image/not_active.png" border="none" width="10"> ';
                $link .= $this->content;

            }else{
                $link .= '<img src="' . PROJECT_HTTP_ROOT . 'image/enable.png" border="none" width="10"> ';
                $link .= $this->content;
            }
            $link .= '</' . $a_or_span . '></span>';
            return $link;
        }
    }

    /**
     * Plays together with bool_link und check if loeschen was submitted
     * Must be placed on the top of the file
     * 
     * @param string $table Tabelle
     */
    function set_bool_query($table)
    {
        if(isset($_REQUEST[$this->field_name]) ) {
            // abs = value of -1 without - (minus)
            $value = abs($_REQUEST[$this->field_name]-1);
            $sql = "UPDATE $table SET $this->field_name = $value WHERE id = $this->id";
            $this->do_sql($sql);
        }
    }


    
    function set_field_name($param) 
    {
         $this->field_name = $param;
    }

    
    /**
     * Set table
     * 
     * @param string $param 
     */
    function set_table($param) 
    {
         $this->tbl = $param;
    }

    
    /**
     * Set id of record
     * 
     * @param int $param 
     */
    function set_id($param) 
    {
         $this->id = $param;
    }


    /**
     * Inscription of link if value = 1
     * 
     * @param string $param 
     */
    function set_content($param) 
    {
         $this->content = $param;
    }

    /**
     * Set the link inactive, f.i. if is not needed.
     */
    function set_inactive() 
    {
         $this->inactive = true;
    }

}

// end class
?>