<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/** Class to calculate the amount from a query
  *
  * Switching means updating the database fields from type bool,
  * Updating will write 0 or 1 to the database.
  *
  * @since 2010-12
  */
class Db_Total extends Dbc 
{

    /**
     * calculate total of material like:
     *      amount * price [* ust]
     *
     * @param str $qry the query string (select * from tbl ...)
     * @param real/int $field1 mostly amount of something f.i. 'amount'
     * @param real/int $field2 in most cases the price, f.i. 'price'
     * @param real/int $field3 for further parameters like tax etc.
     * @return real $sum_rows total of single sum
     */
    function rows_total($qry, $field1, $field2 = '', $field3 = '') {
        $result = $this->query($qry);

        $product_row = 0;
        $sum_rows = 0;
        while($row = $this->fetch_array($result)) {

            // A
            if (empty($field2) and empty($field3)) {
                if(isset($row[$field1])) {  // new
                    $product_row = $row[$field1];
                }

            // A * B
            }elseif (empty($field3)) {
                if(isset($row[$field1]) and isset ($row[$field2])) {  // new
                    $product_row= $row[$field1] * $row[$field2];
                }

            // A * B * C
            }else {
                if(isset($row[$field1]) and isset($row[$field2]) and isset($row[$field3])) {  // new
                 $product_row= $row[$field1] * $row[$field2] * $row[$field3];
                }
            }
            // New
            $sum_rows += $product_row;
        }
        
        return $sum_rows;
    }
}
?>