<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for creating documents in HTML
  * For example invoice, delivery note, order-confirmation etc.
  *
  * @since 2011-07
  */
class Doc_Html extends Doc 
{


/**
 * Print bank and aim in html pages
 */
function print_bank_and_aim()
{
    if ($this->doc == 'invoi') {
        $this->make_bank_and_aim();
        if($this->output_format == 'h') {
            print '<p>' . $this->pay_hint . '</p>';

            if (isset($this->bank_details) and $this->bank_details == true) {
                $this->bank_details = nl2br($this->bank_details);
                print '<p>' . $this->bank_details . '</p>';
            }

            if (isset($this->iban_bic) and $this->iban_bic == true) {
                print '<p>' . $this->iban_bic . '</p>';
            }
            
            if (isset($this->tax_number_id)) {
                print '<p>' . $this->tax_number_id . '</p>';
            }
        }
    }
}


/**
 *
 */
function make_html_sender() 
{
    $this->make_sender();
    
    $sender = '<p><span class="small"> ' .  nl2br($this->sender) . '</span>' 
            . '</p>';
    return $sender;
}

/**
 * 
 */
function print_company_name() 
{
    $bool_print_name = $this->make_company_name();
    
    if ($bool_print_name == true) {
        
        ?>
        <style type="text/css">
        #company_name {
            position: absolute;
            height: auto;
            right: auto;
            bottom: auto;
            left: <?php echo $this->arr_company_xy[0]; ?>mm;
            top: <?php echo $this->arr_company_xy[1]; ?>mm;
        }
        </style>

        <div id="company_name">
        <p>
            <b>
            <?php
            if ($this->adm['company_name_on'] == 1) {
                $company_name = nl2br($this->adm['company_name']);
                print  $company_name;
            }
            ?>
            </b>
        </p>
        </div>
        <?php
    }
}

/**
 * 
 */
function print_logo() 
{
    $bool_print_logo = $this->make_logo();
    
    if ($bool_print_logo == true) {
        ?>
        <style type="text/css">
        #logo {
            position: absolute;
            height: auto;
            right: auto;
            bottom: auto;
            left: <?php echo $this->arr_logo_xy[0]; ?>mm;
            top: <?php echo $this->arr_logo_xy[1]; ?>mm;
        }
        img{
            width: <?php echo $this->adm['logo_width']; ?>mm
        }
        </style>

        <?php

        // Logo
        ?>
        <div id="logo">
            
            <img src="<?php  echo LOGO_HTTP  . $this->adm['logo_url']; ?>"
                 
                    width="<?php print $this->adm['logo_width']; ?>" border="0">
        </div>
        <?php
    }
}


/**
 *
 */
function make_html_address($sender_bool=true) 
{
    $this->make_address();

    // Switch address or delivery address
    if ($this->doc != 'deliv') {
        $address = $this->address;
        $postcode_city = $this->postcode_city;
        
    }elseif($this->doc == 'deliv' and $this->ord['id_tbl_address_deliv'] > 0) {
        $address = $this->address_delivery;
        $postcode_city = $this->postcode_city_delivery;
        
    }else{
        $address = $this->address;
        $postcode_city = $this->postcode_city;
    }
    $address_text = '';
    if ($sender_bool == true) {
        $address_text .= $this->make_html_sender();
    }
    $address_text .= '<p>' . nl2br($address) . '<b>' . nl2br($postcode_city)
                  . '</b>' . '</p>';
    return $address_text;
}


/**
 *
 */
function make_html_delivery_address() 
{
    global $la_invoice_address;
    global $la_delivery_address;
    
    $this->make_address();
    
    if ($this->delivery_address_exist == true) {

        // Switch address or deliv address
        if ($this->doc != 'deliv') {
            $address = $this->address_delivery;
            $postcode_city = $this->postcode_city_delivery;
            $address_kind = $la_delivery_address;

        }else{
            $address = $this->address;
            $postcode_city = $this->postcode_city;
            $address_kind = $la_invoice_address;
        }
        
        $delivery_address = '<p style="font-size: 8pt;">' . $address_kind . '<br>'
                          . nl2br($address) . '<b>' . nl2br($postcode_city) 
                          . '</b></p>';
        return $delivery_address;
    }
}


/**
 *
 */
function print_delivery_date() 
{
    $this->make_delivery_date();
        ?>
        <br>
        <?php
             print nl2br($this->delivery_date);
        ?>
        <?php
}

/**
 * Get the html-align-string f.i. align="center"
 * Input is $this->arr_item_head_align[x], in this case 'C'
 *  
 * @param type $pdf_align
 * @return string 
 */
function get_html_align($pdf_align) {
    // Get align for html tag
    if ($pdf_align == '') {
        $align = 'left';
    }elseif($pdf_align == 'R') {
        $align = 'right';
    }elseif($pdf_align == 'C') {
        $align = 'center';
    }
    $align_tag = ' align="' . $align . '"';
    return $align_tag;
}

/**
 * Print Positions of the order as a table
 *
 */
function print_pos() 
{
    // Table head
    $this->make_pos_head();
    print '<tr>' . "\n";
    foreach($this->arr_item_head as $key => $value) {
        $align_tag = $this->get_html_align($this->arr_item_head_align[$key]);
        print '<th'. $align_tag . '>' . $value . '</th>' . "\n";
    }
    print '</tr>' ."\n";
     
    $html = new Html_Element();
    // Table rows
    // $value important!
    foreach($this->position_rows as $key => $value) { // Rows
        // Table rows
        print $html->make_row($this->position_rows[$key], $this->arr_item_head_align);
    }
    
}


/**
 * Print line shipping
 * @todo make in doc.class this row as array like pos head
 */
function print_shipping() 
{
    // Table rows
    $html = new Html_Element();
    print $html->make_row($this->shipping_row, $this->shipping_align);

}
 

/**
 * 
 */
function print_tax_invoice_included() 
{
    $this->make_tax_invoice_included();
    if($this->ord['tax_on'] == 1  and $this->ord['invoice_gross'] == 1 
            and $this->doc != 'deliv')
    {
            $this->tax_invoice_included_output = nl2br($this->tax_invoice_included_output);
            print '<br/>';
            print '<p>' . $this->tax_invoice_included_output . '</p>';
    }
}


/**
 * 
 */
function make_html_head() 
{
    $head = '<p>' . nl2br($this->head_company) . '</p>'
          . '<p><b>' . $this->doc_name . '</b></p>'
          . '<p>' . nl2br($this->head_document) . '</p>';
    return $head;
}


/**
 *
 * @global <type> $la_legend
 */
function print_abbreviations() 
{
    global $la_legend;
    print '<p class="small">' . $la_legend . '</p>';
}


/**
 * print letter
 *
 */
function print_letter() 
{
    ?>
    <p><b><?php print $this->let['reference']; ?></b></p>
    <p>&nbsp;</p>
    <p>&nbsp;</p>
    <p><?php print nl2br( $this->let['letter_text']); ?></p>
    <?php
}


/**
 * gibt die time_delivery aus
 * @global  $pdf
 */
function print_delivery_time() 
{
    $this->make_delivery_time();
    print '<p>' . $this->delivery_time . '</p>';
}


/**
 * Print small businessman
 */
function print_small_businessman() 
{
    $this->make_small_businessman();
    print '<p>' . $this->small_businessman_output . '</p>';
}


/**
 *
 */
function get_arr_address_xy() 
{
    return $this->arr_address_xy;
}


/**
 *
 */
function get_arr_delivery_address_xy() 
{
    return $this->arr_delivery_address_xy;
}

/**
 *
 */
function get_arr_company_data_xy() 
{
    return $this->arr_company_data_xy;
}


/**
 *
 */
function print_text($class='') 
{
    $this->text_bottom = nl2br($this->text_bottom);
    print '<p ' . $class . '>'. $this->text_bottom . '</p>';
}


/**
 * Print row net
 */
function print_total_net() 
{
    $this->make_total_net();
    $html = new Html_Element();
    $html->set_big_row();
    print $html->make_row($this->arr_amount_net, $this->arr_amount_net_align);
}


/**
 *
 */
function print_tax() 
{
    // $value important 
    foreach ($this->tax_rows as $key => $value) {
        ?>
        <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td colspan="2"><?php print $this->tax_rows[$key][0]; ?> </td>
            <td align="right"><?php print $this->tax_rows[$key][2]; ?></td>
            <?php
             if ($this->adm['tax_column_on'] == 1 and $this->ord['tax_on'] == 1) { 
                 ?>
                    <td>&nbsp;</td>
                 <?php
             }
            ?>
        </tr>
        <?php
    }
}


/**
 *
 */
function print_total_gross() 
{
    $this->make_total_gross();
    ?>
    <tr>
        <td> &nbsp; </td>
        <td> &nbsp; </td>
        <td> &nbsp; </td>
        <td colspan="2"><b><?php print $this->word_total_gross; ?> </b></td>
        <td align="right">
            <b><?php print $this->amount_gross_format; ?></b>
        </td>
            <?php
             if ($this->adm['tax_column_on'] == 1 and $this->ord['tax_on'] == 1) { 
                 ?>
                    <td>&nbsp;</td>
                 <?php
             }
            ?>
    </tr>
    <?php
}


/**
 *
 */
function print_pos_part_pay() 
{
    $this->make_pos_part_pay();
    $html = new Html_Element();
    print $html->make_row($this->arr_pos_part_pay, $this->arr_pos_part_pay_align);
}


/**
 *
 */
function print_part_pay() 
{
    $true_false = $this->make_part_pay();
    if ($true_false == true) {
        ?>
        <tr>
            <td> &nbsp;</td>
            <td> &nbsp; </td>
            <td> &nbsp; </td>
            <td colspan="2">
            <?php 
            print $this->subject_total_part_pay_output; 
            ?>
            </td>
            <td align="right">
                <?php print $this->partpay_total_format; ?>
            </td>
            <td> &nbsp; </td>
        </tr>
        <?php
    }
}


/**
 *
 */
function print_sum_total() 
{
   $true_false = $this->make_sum_total();
   if ($true_false == true) {
        ?>
        <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td colspan="2"><b><?php print $this->word_sum_total; ?></b></td>
            <td align="right"><b>
                <?php print $this->amount_sum_total_format; ?></b>
            </td>
            <td>&nbsp;</td>
        </tr>
        <?php
   }
}


} // end class
?>