<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Dustbin shows a dustbin for hide (not delete) records
 *
 * @since 2011-05
 */
class Dustbin extends Dbc 
{
    private $table;


/**
 * works together with showDustbin 
 * if dusbin or outof the dustbin was pressed field hide will be 
 * changed in the database
 * 
 * must be placed on the top of the file
 *
 * @global type $use
 * @global type $tbl
 * @param type $table 
 */
function set_dustbin($table)
{
    global $use;
    global $tbl;
    
    $this->table = $table;
    if(isset($_GET['hide_row']) ) {
        // value of the number without negativ sign
        $value = abs($_GET['hide_row']-1);

        $data = array( 'hide' => $value);
        $condition = 'id = ' . $_GET['id'];
        $this->update_array($tbl, $data, $condition);
    }
}


/**
 * shows dustbin or out of the dustbin image as a link
 * works together with setDustbin 
 * 
 * @param str $tbl tabellenname
 * @param int $id id, which will be changed
 * @param int $deleted value of field hide 
 * @param array $arr values for query string for go forward
*/
function show_dustbin($id, $deleted, $arr)
{
    $la_get = '';
    foreach($arr as $field => $value ) {
        $value = urlencode($value);
        $la_get .= $field . '=' . $value . '&amp;';
    }
    $la_get = substr($la_get, 0, -1);

    $l = $_SERVER['PHP_SELF'] . '?hide_row=' . $deleted . '&amp;tbl=' 
       . $this->table . '&amp;id=' . $id . '&amp;' . $la_get;
    
    $link = '<a href="' . $l . '">';
    
    if($deleted != 1) {
        $link .= '<img src="'.PROJECT_HTTP_ROOT.'image/waste.png" title="Hide"'
               .' border="none" width="15px"  height="15px" alt="muell">';
        
    }else{
       $link .= '<img src="'.PROJECT_HTTP_ROOT.'image/waste_back.png" ' 
              . ' title="Cancel hide" border="none" '
              .' width="17" height="18" alt="aus dem muell">';
    }
    $link .= '</a>';
    return $link;
}


/**
 * Set short form of table for the query string
 * @param string $tbl name of table
 */
function set_table($tbl)
{
    $this->table = $tbl;
}
    
} // end class