<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Class for modify sql queryes. This works like a filter.
 *
 * Requires: 
 *      -function select_aus_array_auto
 *      -class Dbc
 * 
 * @since 2010-12
 */
class Filter 
{
    protected $arr_options_for_select = array();
    protected $field_name;
    protected $query;
    protected $table;

    /**
     * Sets the field name from the value, which will be displayed
     * The table must have the primary key "id"
     * @param type $field_name 
     */
    function set_table_and_field_name($table, $field_name) 
    {
         $this->field_name = $field_name;
         $this->table = $table;
    }

    
    /**
     *
     * @param type $description_of_all_records 
     */
    function set_first_entry_of_arr_options_for_select($description_of_all_records) 
    {
         $this->arr_options_for_select = array(
                $description_of_all_records => 0,
                );
         $this->make_query();
         $this->make_array_options_for_select();
    }
    
    /**
     * Sets the array when no database is requested
     * 
     * @param type $array 
     */
    function set_array_options_for_select($array) 
    {
         $this->arr_options_for_select = $array;
    }

    /**
     *
     */
    private function make_array_options_for_select() 
    {
        global $db;
        
        $array = $this->arr_options_for_select;
        $result = $db->query($this->query);
        while ($row = $db->fetch_array($result)) {
            $array[$row[$this->field_name]] = $row['id'];
        }
        $this->arr_options_for_select = $array;
    }

    /**
     *
     * @param type $query 
     */
    private function make_query() 
    {
        $query = "
            SELECT id, $this->field_name
            FROM $this->table
            WHERE hide != 1
            ORDER BY $this->field_name";
        $this->query = $query;
    }


    /**
     *
     * @param type $fil_name
     * @param type $width
     * @return string 
     */
    function print_form2($fil_name, $width = 100) {

        if (isset ($_SESSION[$fil_name]) and $_SESSION[$fil_name] != 0) {
            $fett = 'invert';
        }  else {
            $fett = '';
        }
        $output = '';
        $output .= '<div style="display: inline;">';
        $output .= '<form class="inline" method="post" action="query.php">';
        $output .= select_aus_array_auto($this->arr_options_for_select, $fil_name, $width, 1, $fett); 
        $output .= '</form>';
        $output .= '</div>';
        
        return $output;
    }

} // end class

?>