<?php
/**
 * Concept from: Galileo Computing 2010
 * Stefan Reimers and Gunnar Thies: PHP 5.3 & MySQL 5.5
 * ISBN 978-3-8362-1645-6
 * 
 * Structure of a html page
 */

class HTML
{
    
    /**
     * Creates Head
     * 
     * @global type $start_micro
     * @param string $css 
     */
    public static function printHead($css = 'default.css')
    {
        global $start_micro;

        echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'."\r\n";
        echo '<html>' . "\n";
        echo '<head>' . "\n";
        echo '<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">';
        echo '<title>' . WINDOW_TITLE . '</title>' . "\n";

        /**
         * Select css directory: 
         * default = css/
         * other = modul/css/css/
         */
        if ($css == 'default.css' or $css == 'print.css') {
            $css_path = PROJECT_HTTP_ROOT.'css/'.$css;
        }else{
            $css_path = PROJECT_HTTP_ROOT . 'modul/css/css/'.$css;
        }
        echo '<link rel="stylesheet" type="text/css" href="' . $css_path . '">' . "\n";

        // Start taking time of script duration
        $start_micro = microtime(true);
    }


    /**
     * Creates the body of a html page
     *
     * @param type $focus_form_field
     * @param type $css
     * @param type $withConsole 
     */
    public static function printBody($focus_form_field = null, $css = null,$withConsole = true)
    {
            echo '</head>'."\n";
            echo '<body ';
            if ($focus_form_field != null)
            {
                echo 'onload="document.'.$focus_form_field.'.focus()"';
            }
            if ($css != null)
            {
                    echo ' style="'.$css.'"';
            }
            echo '>'."\n";
    }


    /**
     * Beendet ein HTML-Dokument.
     * 
     */
    public static function printFoot()
    {
            global $start_micro;

            // Measurement of script duration
            $end_micro = microtime(true);
            $diff_micro = $end_micro - $start_micro;

            // Returns the script duration
//                echo '<span class="grau">';
//                echo number_format($diff_micro, 4, ",", "." ) . ' sec';
//                echo '</span>';
            #echo '</div>'; 
            echo '</body></html>';
    }


    /**
     * Creates the headline 
     * @param type $headline 
     */
    public static function printHeadline($headline)
    {
            echo '<div class="headline">';
            echo $headline;
            echo '</div>';
    }
	

}
?>